## deepin-scanner 0.1.9

=== debian/changelog ===
deepin-scanner (0.1.9) unstable; urgency=medium

  * update translations

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Fri, 27 Jun 2025 17:34:13 +0800

deepin-scanner (0.1.8) unstable; urgency=medium

  * Update version to 0.1.8
  * Update title of the manual documents.

 -- re2zero <yangwu@uniontech.com>  Tue, 24 Jun 2025 18:24:15 +0800

deepin-scanner (0.1.7) unstable; urgency=medium

  * Merge pull request #12 from Kakueeen/master

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Mon, 23 Jun 2025 14:03:49 +0800

deepin-scanner (0.1.6) unstable; urgency=medium

  * Update version to 0.1.6
  * Update the manual documents.

 -- re2zero <yangwu@uniontech.com>  Thu, 19 Jun 2025 16:11:43 +0800

deepin-scanner (0.1.5) unstable; urgency=medium

  * Update version to 0.1.5
  * chore: [log]Format log and add manual assets.
  * fix: Fix open device failed issue.

 -- re2zero <yangwu@uniontech.com>  Thu, 29 May 2025 19:19:08 +0800

deepin-scanner (0.1.4) unstable; urgency=medium

  * Update version to 0.1.4
  * Fix some UI issues.

 -- re2zero <yangwu@uniontech.com>  Wed, 14 May 2025 13:03:16 +0800

deepin-scanner (0.1.3) unstable; urgency=medium

  * Update version to 0.1.3
  * Add loading dialog.

 -- re2zero <yangwu@uniontech.com>  Tue, 29 Apr 2025 19:21:18 +0800

deepin-scanner (0.1.2) unstable; urgency=medium

  * Update version to 0.1.2
  * Fix mips build.

 -- re2zero <yangwu@uniontech.com>  Tue, 29 Apr 2025 11:08:14 +0800

deepin-scanner (0.1.1) unstable; urgency=medium

  * Frist release version 0.1.1

 -- re2zero <yangwu@uniontech.com>  Thu, 24 Apr 2025 20:20:46 +0800

deepin-scanner (0.1.0) unstable; urgency=medium

  * New version 0.1.0

 -- re2zero <yangwu@uniontech.com>  Thu, 24 Apr 2025 19:14:01 +0800

## deepin-scanner 0.1.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

if (NOT VERSION)
    set(VERSION 1.0.0)
endif()

# 项目基本信息
project(deepin-scanner
    VERSION ${VERSION}
    DESCRIPTION "Deepin scanner manager"
    LANGUAGES CXX C
)

message(">>> Version: ${PROJECT_VERSION}")

# 设置C++标准
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(GNUInstallDirs)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
# 引入翻译生成
include(translation-generate)

# 查找Qt版本
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
message(">>> Found Qt version: ${QT_VERSION_MAJOR}")
set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})

# 设置DTK版本
if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
endif()
message(">>> Build with DTK: ${DTK_VERSION_MAJOR}")

# 定义必需的Qt组件
set(qt_required_components Core Gui Widgets Concurrent)

# 添加Qt6特有组件
if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND qt_required_components Core5Compat)
endif()

# 查找Qt和DTK
find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
# 查找DTK并添加包含路径
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget Gui Core)
include_directories(${Dtk${DTK_VERSION_MAJOR}_INCLUDE_DIRS})

# 定义链接库
set(LINK_LIBS
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::Gui
    Qt${QT_DESIRED_VERSION}::Widgets
    Qt${QT_DESIRED_VERSION}::Concurrent
    Dtk${DTK_VERSION_MAJOR}::Widget
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Core
)

# # 添加Qt6特有链接库
# if (QT_DESIRED_VERSION MATCHES 6)
#     list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
# endif()

# 安全编译选项
add_compile_options(
    -fstack-protector-strong
    -D_FORTIFY_SOURCE=2
    -fPIC
    -pie
    -Wno-unused-parameter
)

# add_link_options(
#     -pie
#     -z lazy
# )

# 添加子项目
add_subdirectory(src)
# add_subdirectory(tests)

# translation files
TRANSLATION_GENERATE(QM_FILES ${CMAKE_SOURCE_DIR}/translations)
add_custom_target(${PROJECT_NAME}_qm_files DEPENDS ${QM_FILES})
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_qm_files)

# Install translations
install(FILES ${QM_FILES} DESTINATION share/${PROJECT_NAME}/translations)

# Install help manual
install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/deepin-scanner DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-manual/manual-assets/application/)

# log viewer config
file(GLOB LOGCONFIG_FILES "${CMAKE_SOURCE_DIR}/assets/logconfig/*.json")
install(FILES ${LOGCONFIG_FILES} DESTINATION share/deepin-log-viewer/deepin-log.conf.d)

# 安装 DConfig 配置文件，1040及以下的默认DTK环境不支持DConfig
set(DCONFIG_APPID org.deepin.scanner)
file(GLOB DCONFIG_FILES "${CMAKE_SOURCE_DIR}/assets/configs/*.json")
if(DEFINED DSG_DATA_DIR)
    if (DTK_VERSION_MAJOR EQUAL "6")
        dtk_add_config_meta_files(APPID ${DCONFIG_APPID} FILES ${DCONFIG_FILES})
    else()
        dconfig_meta_files(APPID ${DCONFIG_APPID} FILES ${DCONFIG_FILES})
    endif()
    message("-- DConfig is supported by DTK")
else()
    install(FILES ${DCONFIG_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/configs/${DCONFIG_APPID})
    message("-- DConfig is not supported by DTK")
endif()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# project(deepin-scanner)

add_subdirectory(libofd)

# --- Find SANE and PNG using pkg-config (more robust) ---
# Only on non-Windows systems
if(UNIX AND NOT APPLE)
    # Find pkg-config itself
    find_package(PkgConfig REQUIRED)

    # Use pkg-config to find SANE (usually provided as 'sane-backends')
    pkg_check_modules(SANE REQUIRED sane-backends)

    if(SANE_FOUND)
        message(STATUS "Found SANE: TRUE (via pkg-config)")
        include_directories(${SANE_INCLUDE_DIRS}) # Add include directories
    else()
        message(FATAL_ERROR "SANE library (sane-backends) not found by pkg-config. Is libsane-dev installed?")
    endif()

    # Use pkg-config to find PNG (usually provided as 'libpng')
    pkg_check_modules(PNG REQUIRED libpng)

    if(PNG_FOUND)
        message(STATUS "Found PNG: TRUE (via pkg-config)")
        include_directories(${PNG_INCLUDE_DIRS}) # Add include directories
    else()
        message(FATAL_ERROR "PNG library (libpng) not found by pkg-config. Is libpng-dev installed?")
    endif()
endif()

# 收集所有源文件
file(GLOB SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/ui/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/ui/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/device/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/device/*.h"
)

# 定义可执行文件
add_executable(${PROJECT_NAME}
    ${SOURCES}
)

# 启用自动moc处理
set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOMOC ON
    AUTORCC ON
    AUTOUIC ON
)

target_compile_definitions(${PROJECT_NAME} PRIVATE
    INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
    APP_VERSION="${VERSION}"
)

# 包含目录
target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

# 设置包含 Qt 头文件的路径
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# 链接库
target_link_libraries(${PROJECT_NAME} PRIVATE
    ${LINK_LIBS}
    ofdcpp
)

# --- 链接 SANE 和 PNG (仅在非 Windows 系统) ---
if(UNIX AND NOT APPLE)
    # Use variables set by pkg_check_modules
    if(SANE_FOUND AND PNG_FOUND)
        target_link_libraries(${PROJECT_NAME} PRIVATE ${SANE_LIBRARIES} ${PNG_LIBRARIES})
        message(STATUS "Linking with SANE and PNG libraries (found via pkg-config).")
    endif()

    # No need for else here, pkg_check_modules already handles REQUIRED errors
endif()

# 添加资源文件
if(QT_DESIRED_VERSION MATCHES 6)
    qt_add_resources(qrc_RESOURCES
        ${CMAKE_SOURCE_DIR}/resources/resources.qrc
    )
else()
    qt5_add_resources(qrc_RESOURCES
        ${CMAKE_SOURCE_DIR}/resources/resources.qrc
    )
endif()

target_sources(${PROJECT_NAME} PRIVATE ${qrc_RESOURCES})

# 安装目标
install(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# 安装桌面文件和图标
install(FILES
    ${CMAKE_SOURCE_DIR}/resources/deepin-scanner.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(FILES
    ${CMAKE_SOURCE_DIR}/resources/icons/deepin/builtin/icons/deepin-scanner.svg
    DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps
)

# # 安装帮助文件
# install(DIRECTORY
# ${CMAKE_SOURCE_DIR}/assets/
# DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application
# )

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# 启用测试
enable_testing()

# 查找Qt Test模块
find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS Test)

# 添加测试可执行文件
add_executable(tests_shared_ptr
    test_shared_ptr.cpp
)

# 包含主项目头文件
target_include_directories(tests_shared_ptr PRIVATE
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_SOURCE_DIR}/src/device
    ${CMAKE_SOURCE_DIR}/src/ui
)

# 链接Qt Test库和主项目
target_link_libraries(tests_shared_ptr PRIVATE
    Qt${QT_DESIRED_VERSION}::Test
    ${PROJECT_NAME}
)

# 启用自动moc处理
set_target_properties(tests_shared_ptr PROPERTIES
    AUTOMOC ON
    AUTORCC ON
    AUTOUIC ON
)

# 添加测试
add_test(NAME test_shared_ptr COMMAND tests_shared_ptr)

=== src/libofd/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(ofdcpp VERSION 0.1.0 LANGUAGES CXX)

# Build options
option(BUILD_EXAMPLES "Build example applications" OFF)
option(BUILD_TESTS "Build test applications" OFF)

# C++ standard settings
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Add cmake module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Source files
file(GLOB SOURCES
    "src/ofd_reader.cpp"
    "src/ofd_writer.cpp"
)

file(GLOB HEADERS
    "include/ofd/*.h"
)

find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS Core Gui Xml)

# 使用 pkg-config 查找 QuaZip
find_package(PkgConfig REQUIRED)

if(QT_DESIRED_VERSION MATCHES 6)
    pkg_check_modules(QUAZIP REQUIRED quazip1-qt6)
else()
    pkg_check_modules(QUAZIP quazip1-qt5 QUIET)

    if(NOT QUAZIP_FOUND)
        # find the old quazip package
        message(STATUS "quazip1-qt5 not found, trying to find the old package libquazip5-dev")
        find_package(QuaZip5 REQUIRED)
    endif()
endif()

message(STATUS "QuaZip Include Dirs: ${QUAZIP_INCLUDE_DIRS}")
message(STATUS "QuaZip Libraries: ${QUAZIP_LIBRARIES}")

add_library(ofdcpp STATIC ${SOURCES} ${HEADERS})

target_include_directories(${PROJECT_NAME}
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${QUAZIP_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME}
    PUBLIC
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::Gui
    Qt${QT_DESIRED_VERSION}::Xml
    ${QUAZIP_LIBRARIES}
)

# # 安装头文件
# install(DIRECTORY include/ofd
#     DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
# )

# 然后再构建示例
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

=== src/libofd/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(ofd_examples VERSION 0.1.0 LANGUAGES CXX)

# 设置C++标准
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# 设置cmake模块路径
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

# 添加选项用于指定Qt版本
option(USE_QT6 "Use Qt6 instead of Qt5" OFF)

if(USE_QT6)
    find_package(Qt6 COMPONENTS Core Gui Xml Widgets REQUIRED)
    find_package(QuaZip-Qt6 REQUIRED)  # 修改为正确的包名
    set(QT_VERSION_MAJOR 6)
else()
    find_package(Qt5 COMPONENTS Core Gui Xml Widgets REQUIRED)
    find_package(QuaZip5 REQUIRED)
endif()

# 添加可执行文件
add_executable(simple_example simple_example.cpp)

# 添加包含路径
target_include_directories(simple_example
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../include
)

# 设置链接
if(USE_QT6)
    target_link_libraries(simple_example
        PRIVATE
            ofdcpp6
            Qt${QT_VERSION_MAJOR}::Core
            Qt${QT_VERSION_MAJOR}::Gui
            Qt${QT_VERSION_MAJOR}::Xml
            Qt${QT_VERSION_MAJOR}::Widgets
    )
else()
    # Qt5 链接，使用原来正确的方式
    target_link_libraries(simple_example
        PRIVATE
            ofdcpp
            Qt${QT_VERSION_MAJOR}::Core
            Qt${QT_VERSION_MAJOR}::Gui
            Qt${QT_VERSION_MAJOR}::Xml
            Qt${QT_VERSION_MAJOR}::Widgets
    )
endif()

## deepin-scanner 0.1.12

=== debian/changelog ===
deepin-scanner (0.1.12) unstable; urgency=medium

  * Update version to 0.1.12
  * Fix black-white image save issues.

 -- re2zero <yangwu@uniontech.com>  Wed, 16 Jul 2025 10:19:19 +0800

deepin-scanner (0.1.11) unstable; urgency=medium

  * Update version to 0.1.11
  * Fix combo box select block and black-white image save issues.

 -- re2zero <yangwu@uniontech.com>  Thu, 10 Jul 2025 16:38:16 +0800

deepin-scanner (0.1.10) unstable; urgency=medium

  * chore: update translations

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Tue, 01 Jul 2025 19:48:16 +0800

=== debian/control ===

Source: deepin-scanner
Section: graphics
Priority: optional
Maintainer: deepin <packages@deepin.com>
Build-Depends:
 debhelper (>= 11),
 pkg-config,
 cmake,
 qt6-5compat-dev | libqt5x11extras5-dev,
 qt6-base-dev | qtbase5-dev,
 qt6-tools-dev-tools | qttools5-dev-tools,
 qt6-tools-dev | qttools5-dev,
 libdtk6widget-dev | libdtkwidget-dev,
 libdtk6gui-dev | libdtkgui-dev,
 libdtk6core-dev | libdtkcore-dev,
 libquazip1-qt6-dev | libquazip1-qt5-dev | libquazip5-dev,
 libsane-dev,
 libtiff-dev,
 libjpeg-dev,
 libicu-dev,
 libpng-dev,
Standards-Version: 4.5.0

Package: deepin-scanner
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
Description: a tool for scanning.
 Scanner Manager is a tool for scanning document files, supporting PDF, JPEG, PNG, TIFF.

## deepin-scanner 0.1.15

=== debian/changelog ===
deepin-scanner (0.1.15) unstable; urgency=medium

  * chore: Add new Lao translation file

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 14 Aug 2025 09:20:32 +0800

deepin-scanner (0.1.14) unstable; urgency=medium

  * chore: Add new Lao translation file

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 07 Aug 2025 17:51:54 +0800

deepin-scanner (0.1.13) unstable; urgency=medium

  * Update version to 0.1.13
  * Fix some scanner issues.

 -- re2zero <yangwu@uniontech.com>  Mon, 21 Jul 2025 16:13:32 +0800

## deepin-scanner 0.1.17

=== debian/changelog ===
deepin-scanner (0.1.17) unstable; urgency=medium

  * chore: Update version to 0.1.17
  * chore: Adjust pkg-config dependency

 -- zhanghongyuan <zhanghongyuan@uniontech.com>  Fri, 17 Oct 2025 08:35:29 +0800

deepin-scanner (0.1.16) unstable; urgency=medium

  * chore: Update version to 0.1.16

 -- zhanghongyuan <zhanghongyuan@uniontech.com>  Thu, 16 Oct 2025 19:25:00 +0800

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Maintainer: deepin <packages@deepin.com>
 Build-Depends:
  debhelper (>= 11),
+ cmake,
  pkg-config,
- cmake,
  qt6-5compat-dev | libqt5x11extras5-dev,
  qt6-base-dev | qtbase5-dev,
  qt6-tools-dev-tools | qttools5-dev-tools,

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

# 有的Qt5环境需要设置环境变量，Qt6不需要
export QT_SELECT=5

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

DH_AUTO_ARGS = --parallel --buildsystem=cmake

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_SAFETYTEST_ARG="CMAKE_SAFETYTEST_ARG_OFF" \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DQT_DIR=$(QT_DIR)
